<!-- <div class="row mt-2">

    <div class="col-md-12">
        <form class="form-inline">
            <div class="form-group">
                <label>
                    <h3 class="card-title-material mb-0">Keywords</h3>
                </label>
                <input style="width: 82vw; max-width: calc(82vw - 150px); margin-left: 15px;" class="form-control user-input-material" type='text'
                    placeholder='Search' (keyup)='updateFilter($event)'>
            </div>
        </form>
    </div>
</div> -->
<div class="container-m--x bredcrumb admin-bg" style="margin-top:-11.9px;">
    <div class="row px-4 f-16 white">
       <div class="col-md-4">
          <span (click)="goToDefaultPage()" class="cursor"><i class="las la-home f-18 "></i></span>
          <span class="px-3"><i class="las la-angle-right f-12 "></i></span>
          <span class="font-weight-normal">Administration</span>
       </div>
    </div>
  </div>
<div>
    <div class="content">
        <div class="content_width">
            <div class="row">
                <div class="col-md-3 sidebar_top">
                <admin-sidebar></admin-sidebar> 
                </div>
                <div class="col-md-9 card_title_top keywords_table">
                    <label>
                        <h2 class="card-title-material">Keywords</h2>
                    </label>
                    <div class="table-wrapper mt-2">
                        <div class="row py-3">
                                <div class="input-group align-items-center pl-4" style="width:30%;">
                                    <span ><i class="las la-search f-20 search_icon_transform"></i>
                                    </span >
                    <input id="search" class="form-control border-0 px-2 search_bg" type='search' placeholder='Search'
                    (keyup)='updateFilter($event)'>
                </div>

            <!-- <hr class="hr-border container-m--x mt-3 mb-3"> -->
                    <!-- <h3 class="pull-left">Keyword Mappings
                        <button class="btn btn-md btn-primary pull-right" (click)="modalService.open(addNewKeywordModal,{})">
                            <span class="fa fa-plus"></span> Add Keyword</button>
                    </h3> -->

                        <div *ngIf="dataSources.length > 1" class="ml-auto pr-4">
                         
                            <label class="form-label label-text-custom pl-4">Data Source</label>
                            <span class="pl-1 pr-2"
                                placement="top" ngbTooltip="Select the data source to view the list of attributes in it">
                                <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                            </span>
                            <ng-select placeholder="Select source" [allowClear]="false"
                        (ngModelChange)="loadingIndicator=true;loadKeywordsListData()" [options]="dataSources"
                        [(ngModel)]="selectedDataSource" class="data_source_select data-s-enable  custom-border-select option-material data_source_select_width">
                    </ng-select>
                            <!-- <select class="custom-select" [(ngModel)]="selectedDataSource"
                                (change)="loadingIndicator=true;loadKeywordsListData()">
                                <option class="option-material data_source_select data-s-enable  custom-border-select" *ngFor="let opt of dataSources" [value]="opt.entity_name"
                                    [selected]="opt.selected == true">{{opt.entity_description}}</option>
                            </select> -->
                         
                        </div>
                        <!-- <div [ngClass]="dataSources.length > 1 ? 'form-group col-sm-12 col-md-12 mb-0' : 'col-sm-12 col-md-12 mb-0'">
                            <label class="form-label label-text-custom">Search</label>
                                <button class="btn btn-xs btn-outline-info borderless  ion-theme-bg" placement="top"
                                ngbTooltip="Search for Attributes">
                                <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                              </button>
                              <input style="margin-top: 3px;" class="form-control user-input-material" type='text' placeholder='Search'
                              (keyup)='updateFilter($event)'>
                        </div> -->
        <!-- <div class="col-md-2">
            <h3 class="card-title-material mt-2">Keywords</h3>
        </div>
        <div class="col-md-10">
            <input class="form-control user-input-material" type='search' placeholder='Search'
                (keyup)='updateFilter($event)'>
        </div> -->
</div>


    <div *ngIf="!detectmob()" class="card-ngx-datatable table-responsive">
            <ngx-datatable #table  [rows]="rows" style="min-width: 50vh"
                                [loadingIndicator]="loadingIndicator"  [scrollbarH]="scrollBarHorizontal"  [columnMode]="'force'" [headerHeight]="33"
                                [footerHeight]="'auto'" [rowHeight]="'auto'" [reorderable]="true" [limit]="10">

            <!-- <ngx-datatable-column name="entitydescription">
                    <ng-template let-column="column" ngx-datatable-header-template>
                        Data Source
                    </ng-template>
                </ngx-datatable-column> -->
            <ngx-datatable-column name="attrdescription" [width]="200">
                <ng-template let-column="column" ngx-datatable-header-template>
                    Attribute Name
                </ng-template>
            </ngx-datatable-column>
            <ngx-datatable-column name="attrdefinition" [width]="200">
                <ng-template let-column="column" ngx-datatable-header-template>
                    Attribute Definition
                </ng-template>
            </ngx-datatable-column>
            <!-- <ngx-datatable-column name="isUpdated">
                <ng-template let-column="column" ngx-datatable-header-template>
                    Customer Changed
                </ng-template>
            </ngx-datatable-column> -->
            <!-- <ngx-datatable-column name="attrname">
                <ng-template let-column="column" ngx-datatable-header-template>
                    Attribute Name
                </ng-template>
            </ngx-datatable-column> -->
            <!-- <ngx-datatable-column name="attrtype">
                <ng-template let-column="column" ngx-datatable-header-template>
                    Type
                </ng-template>
            </ngx-datatable-column> -->

            <ngx-datatable-column name="synonyms" [width]="400">
                <ng-template let-column="column" ngx-datatable-header-template>
                    Keywords
                </ng-template>

            </ngx-datatable-column>

            <!-- <ngx-datatable-column name="includedattr">
                <ng-template let-column="column" ngx-datatable-header-template>
                    Related Attribute
                </ng-template>
                <ng-template let-row="row" let-value="value" ngx-datatable-cell-template>
                    <span class="badge badge-default ml-2" *ngFor="let r of value">{{r}}</span>
                </ng-template>
                <ng-template let-row="row" let-value="value" ngx-datatable-cell-template>
                    <span class="badge badge-default ml-2" *ngFor="let r of value">{{r.includedattr}}</span>
                </ng-template>
            </ngx-datatable-column> -->
            <ngx-datatable-column name="opration" [width]="150">
                <ng-template let-column="column" ngx-datatable-header-template>
                    Action
                </ng-template>
                <ng-template let-row="row" let-value="value" let-rowIndex="rowIndex" ngx-datatable-cell-template>
                    <!-- <button class="btn icon-btn btn-sm btn-outline-info  " placement="bottom"
                        ngbTooltip="Edit" (click)="modalService.open(testdModal,{})" *ngIf="!detectmob()">
                        Test
                    </button> -->
                    <button class="btn custom-icon-btn btn-sm btn-outline-info  borderless"
                        placement="top" ngbTooltip="Edit" (click)="edit(editKeywordModal,row,rowIndex)"
                        *ngIf="!detectmob()">
                        <i class="fa-lg las la-edit"></i>
                    </button>
                    <!-- Buttons for mobile with tool tip -->
                    <!-- <button class="btn icon-btn btn-sm btn-outline-danger  tooltipMob"
                        (press)="onLongPress('Test')" (pressUp)="onPressUp()" (tap)="test(value)"
                        [disabled]="row['admin']" *ngIf="detectmob()">
                        <i class="fa-lg las la-trash"></i>
                        <span class="tooltiptext" *ngIf="mobTooltipStr != ''">{{mobTooltipStr}}</span>
                    </button> -->
                    <button
                        class="btn custom-icon-btn btn-sm btn-outline-info  tooltipMob borderless"
                        (press)="onLongPress('Edit')" (pressUp)="onPressUp()"
                        (tap)="edit(editKeywordModal,rowIndex)" *ngIf="detectmob()">
                        <i class="fa-lg las la-edit"></i>
                        <span class="tooltiptext" *ngIf="mobTooltipStr != ''">{{mobTooltipStr}}</span>
                    </button>
                    <!--/ Buttons for mobile with tool tip -->

                    <!-- <button class="btn icon-btn btn-sm btn-outline-danger borderless" placement="bottom" ngbTooltip="Delete" (click)="delete(value)" [disabled]="row['admin']">
                            <i class="fa-lg las la-trash"></i>
                        </button> -->

                </ng-template>
            </ngx-datatable-column>
        </ngx-datatable>
    </div>
</div>
</div>
</div>
</div>
</div>
</div>
<!-- <ng-template #addNewKeywordModal let-c="close" let-d="dismiss">
    <div class="admin_panel modal-header">
        <h5 class="modal-title">
            Add New Keyword
        </h5>
        <button type="button" class="close" (click)="d('Cross click')">&times;</button>
    </div>
    <div class="modal-body">
        <div class="form-row">
            <div class="form-group col-md-12">
                <label class="form-label">Attribute Description</label>
                <input name="attributedesc" type="text" class="form-control" placeholder="Attribute Description">
            </div>
        </div>
        <div class="form-row">
            <div class="form-group col-md-12">
                <label class="form-label">Attribute Name</label>
                <input name="attributedesc" type="text" class="form-control" placeholder="Attribute Name">
            </div>
        </div>
        <div class="form-row">
            <div class="form-group col-md-12">
                <label class="form-label">Synonyms</label>
                <input name="attributedesc" type="text" class="form-control" placeholder="Synonyms">
            </div>
        </div>
        <div class="form-row">
            <div class="form-group col-md-12">
                <label class="form-label">Include Attribute</label>
                <ng-select style="color:#a4a4a4;" [multiple]="true" [options]="attributeList"
                    [(ngModel)]="attrIncludedModel">
                </ng-select>
            </div>
        </div>
        <div class="form-row mb-3">
            <div class="form-group col-md-12">
                <button class="btn btn-primary float-right" (click)="d('Cross click')">Save</button>
                <button class="btn btn-default float-right mr-2"
                    (click)="d('Cross click')">Cancel</button>
            </div>
        </div>
    </div>
</ng-template> -->
<ng-template #editKeywordModal let-c="close" let-d="dismiss">
    <div class="admin_panel modal-header">
        <h5 class="modal-title">
            Edit Keyword
            <!-- for Measure {{editAttributedesc}} from Data Source {{viewDatasource}} -->
        </h5>
        <button type="button" class="close" (click)="d('Cross click')">&times;</button>
    </div>
    <div class="modal-body">
        <div class="form-row" *ngIf="!isTesting">
            <!-- <div class="form-group col-md-6">
                    <label class="form-label">Attribute Name</label>
                    <input name="attrname" type="text" class="form-control" placeholder="Attribute Name"
                        [(ngModel)]="editObj.attrname" readonly>
                </div> -->
            <div class="form-group col-md-6">
                <label class="form-label">Attribute Name</label>
                <span class="ml-2  "
                    placement="top" ngbTooltip="Show Attribute Name">
                    <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                </span>
                <input name="attrdescription" type="text" class="form-control" placeholder="Attribute Description"
                    [(ngModel)]="attrDescModel" readonly>
            </div>
            <div class="form-group col-md-6">
                <label class="form-label">Attribute Definition</label>
                <span class="ml-2  "
                    placement="top" ngbTooltip="Add Attribute Definition">
                    <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                </span>
                <textarea style="line-height: 0.54;" name="attrdefinition" class="form-control"
                    placeholder="Attribute Definition" [(ngModel)]="attrDefinition">
                        </textarea>
            </div>
            <div class="form-group col-md-12 d-none">
                <label class="form-label">Include Attribute</label>
                <ng-select [multiple]="true" [options]="attributeList" [(ngModel)]="attrIncludedModel">
                </ng-select>
            </div>

            <div class="form-group col-md-6">
                <label class="form-label">Synonyms</label>
                <span class="ml-2  "
                    placement="top" ngbTooltip="Add Synonyms">
                    <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                </span>
                <div class="input-group">
                    <input name="synonyms" type="text" class="form-control" placeholder="Synonyms"
                        [(ngModel)]="synonymModel" (keyup)="validate()">
                    <span class="input-group-append">
                        <button [ladda]="isSynonymsLoading" data-style="zoom-in"
                            class="btn btn-secondary waves-effect" type="button" style="z-index:0;"
                            (click)="addSynonym()"><i class="fa fa-plus"></i></button>
                    </span>
                </div>
                <span class="invalid-feedback" style="display:block" *ngIf="valid.status">{{valid.msg}}</span>
            </div>

            <div class="form-group col-md-6">

                <label class="form-label">Added Synonyms</label>
                <span class="ml-2  "
                    placement="top" ngbTooltip="Added Synonyms for the attribute">
                    <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                </span>
                <div class="py-2"
                    style="border:1px solid #e0e0e0;border-radius: 5px;width:100%;min-height:38px;background: #f0f0f0">
                    <span class="badge badge-pill badge-default ml-2"
                        *ngFor="let syn of synonymsList; let i = index;">{{syn}} <i class="ion ion-md-close"
                            (click)="removeSynonym(i, syn)"></i>
                    </span>
                </div>
            </div>

        </div>
        <div class="form-row" *ngIf="isTesting">
            <div class="form-group col-md-12">
                <label class="form-label">Search Query</label>
                <button class="btn btn-xs btn-outline-info borderless  ion-theme-bg"
                    placement="top"
                    ngbTooltip="Search with a test question to test your added synonyms. And the result will populate at the bottom">
                    <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                </button>

                <div class="input-group">
                    <input name="searchQuery" type="text" class="form-control" (keyup.enter)="testKeywordResults()"
                        placeholder="E.g: Top Selling Stores" [(ngModel)]="searchQuery">
                    <span class="input-group-append">

                        <button [ladda]="isSearchLoading" data-style="zoom-in"
                            class="btn btn-secondary waves-effect" type="button" (click)="testKeywordResults()">
                            <i class="fa fa-search"></i>
                        </button>
                    </span>
                </div>

            </div>
        </div>
        <div *ngIf="isTesting && !testResult" style="height:400px;width:100%"></div>
        <div *ngIf="testResult" style="height:400px;width:100%">
            <!-- Load the Entity-->
            <!-- <div class="text-center" style="height:300px;width:100%">
                        Loading....
                    </div> -->
            <div *ngIf="pivotResult && pivotResult.dataSource.data.length >1; else isServerFailed"
                class="pivot-table-dialog">
                <fm-pivot #pivotcontainer [width]="'100%'" [height]="380" [toolbar]="false" [id]="pivot-container"
                    [report]="pivotResult" [global]=pivotGlobal
                    [licenseKey]="'Z7TE-102510-6Z0345-61393B-585P5Q-3X053C-5F5P3O-1B2038-6T164M-6F1V6W-0K61'">
                </fm-pivot>
            </div>
        </div>

        <div *ngIf="!isTesting && !(changeLogReport && changeLogReport.dataSource && changeLogReport.dataSource.data && changeLogReport.dataSource.data.length>1)"
            style="width:100%">
            <div class="pivot-table-dialog">
                <fm-pivot #pivotcontainer [width]="'100%'" [height]="300" [toolbar]="false" [id]="pivot-container1"
                    [report]="changeLogReport" [global]=pivotGlobal1
                    [licenseKey]="'Z7TE-102510-6Z0345-61393B-585P5Q-3X053C-5F5P3O-1B2038-6T164M-6F1V6W-0K61'">
                </fm-pivot>
            </div>
        </div>


        <div *ngIf="!isTesting && changeLogReport && changeLogReport.dataSource && changeLogReport.dataSource.data && changeLogReport.dataSource.data.length>1"
            style="width:100%">
            <!-- Load the Entity-->
            <!-- <div class="text-center" style="height:300px;width:100%">
                        Loading....
                    </div> -->
            <div class="pivot-table-dialog">
                <fm-pivot #pivotcontainer [width]="'100%'" [height]="300" [toolbar]="false" [id]="pivot-container1"
                    [report]="changeLogReport" [global]=pivotGlobal1
                    [licenseKey]="'Z7TE-102510-6Z0345-61393B-585P5Q-3X053C-5F5P3O-1B2038-6T164M-6F1V6W-0K61'">
                </fm-pivot>
            </div>
        </div>
    </div>

    <div class="admin_panel modal-footer">
        <div class="form-row">

            <button class="btn btn-default float-right mr-2" *ngIf="isBack"
                (click)="searchQuery='';testResult=false;isBack=false;isTesting=false">Back</button>
            <button class="btn btn-default float-right mr-2"
                (click)="testResult=false;d('Cross click')">Cancel</button>
            <button class="btn btn-default float-right mr-2" *ngIf="!isBack"
                (click)="testResult=false;isTesting=true;isBack=true">Test</button>
            <button class="btn btn-primary float-right" (click)="testResult=false;updateKeyword(d)">Apply
            </button>


        </div>
    </div>


</ng-template>
<ng-template #testdModal let-c="close" let-d="dismiss">
    <div class="admin_panel modal-header">
        <h5 class="admin_panel modal-title">
            Test the Keyword
        </h5>
        <button type="button" class="close" (click)="d('Cross click')">&times;</button>
    </div>
    <div class="admin_panel modal-body">
        <div class="form-row mb-3">
            <div class="form-group col-md-12">
                <div class="input-group">
                    <input name="attributedesc" type="text" class="form-control" placeholder="Search Query">
                    <span class="input-group-append">
                        <button class="btn btn-secondary waves-effect"><i class="fa fa-search"></i></button>
                    </span>
                </div>

            </div>
        </div>

    </div>


</ng-template>

<ng-template #noRecordResult>
    <div class="empty-data-bg">
        <img _ngcontent-c9="" class="emptyDashboardImg alptyAlertImg" src="assets/imgs/hxIcon/emptydb.png">
        <p>No Result Found.</p>
    </div>
</ng-template>
<ng-template #isServerFailed>
    <div *ngIf="serverFailed.status; else noRecordResult" class="empty-data-bg">
        <img _ngcontent-c9="" class="emptyDashboardImg alptyAlertImg" src="assets/imgs/hxIcon/emptydb.png">
        <p>{{serverFailed.msg}}</p>
    </div>
</ng-template>
<div *blockUI="'global-loader'; template: blockTemplate"></div>
<ng-template #blockTemplate>
    <div class="block-ui-template">
        <div class="app-splash-screen ">
            <div class="new-app-splash-screen-content text-center">
                <img src="../../assets/img/hx-loader-logo.svg" class="loader-svg">
                <span class="loading-text-material">
                </span>
            </div>
        </div>
    </div>
</ng-template>